package com.example.chatclient;

import android.widget.TextView;

import org.w3c.dom.Text;

import java.io.DataInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.net.Socket;

public class Client extends Thread {

    WriteThread writeThread;

    public void send(String msg) {
        writeThread.setMessage(msg);
    }

    @Override
    public void run() {
        Socket socket = null;
        try {
            socket = new Socket("192.168.0.2", 9125);

//            ReadThread readThread = new ReadThread(socket);
            writeThread = new WriteThread(socket);

//            readThread.start();
            writeThread.start();

//            readThread.join();
            writeThread.join();

        } catch (IOException | InterruptedException e) {
            e.printStackTrace();
            if (socket != null) {
                try {
                    socket.close();
                } catch (IOException exception) {
                    exception.printStackTrace();
                }
            }
        }
    }
}

class ReadThread extends Thread {
    private Socket socket;

    public ReadThread(Socket socket) {
        this.socket = socket;
    }

    @Override
    public void run() {
        while (!isInterrupted()) {
            try {
                DataInputStream ois = new DataInputStream(socket.getInputStream());

                String o = ois.readLine();

                System.out.print("\033[1;31m\033[40m " + o + ": \u001B[0m ");
                System.out.println(o);


            } catch (IOException exception) {
                exception.printStackTrace();
                try {
                    socket.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                return;
            }
        }
    }
}

class WriteThread extends Thread {
    private Socket socket;
    private final String Name = "Alec";
    private boolean isMessage = false;
    private String message;

    public WriteThread(Socket socket) {
        this.socket = socket;
    }

    public void setMessage(String message) {
        isMessage = true;
        this.message = message;
    }

    @Override
    public void run() {
        while (!isInterrupted()) {
            if (!isMessage) {
                continue;
            }
            isMessage = false;
            try {
                ObjectOutputStream ois = new ObjectOutputStream(socket.getOutputStream());

                Transport t = new Transport();
                t.Name = this.Name;
                t.Message = message;

                ois.writeObject(t);
                ois.flush();

            } catch (IOException exception) {
                exception.printStackTrace();
                try {
                    socket.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                return;
            }
        }
    }
}
